diff -uwr sourceold/crates/crates.cpp source/crates/crates.cpp
--- sourceold/crates/crates.cpp	2011-10-11 21:32:46.643554600 +0800
+++ source/crates/crates.cpp	2011-12-05 15:38:18.435078100 +0800
@@ -22,6 +22,8 @@
 class Crate : public Plugin
 {
 public:
+	struct Configuration
+	{
 	bool EnableCrates;
 	bool EnableNewCrates;
 	bool VehCrate;
@@ -42,18 +44,35 @@
 	int	CrateSpy;
 	int	CrateStealth;
 	int	CrateThief;
-	bool CrateExists;
-	int	CrateLastPickup;
 	int CrateAmmoRegen;
 	int CrateHumanSilo;
 	int CrateUberWire;
-	int CrateID;
-	Crate() : CrateExists(false), CrateLastPickup(-181), CrateID(0), EnableCrates(false), EnableNewCrates(false), VehCrate(false)
+
+		void setToDefaults()
 	{
+			EnableCrates = true;
+			EnableNewCrates = false;
+			VehCrate = false;
 		CrateVehSpawnPos[0] = Vector3(0,0,0);
 		CrateVehSpawnPos[1] = Vector3(0,0,0);
+		}
+	};
+
+	Configuration globalConfiguration;
+	Configuration mapConfiguration;
+	int CrateID;
+	int CrateLastPickup;
+	bool CrateExists;
+
+	Crate()
+	{
+		CrateID = 0;
+		CrateExists = false;
+		CrateLastPickup = -181;
+
 		RegisterEvent(EVENT_GAME_OVER_HOOK,this);
 		RegisterEvent(EVENT_GLOBAL_INI,this);
+		RegisterEvent(EVENT_MAP_INI,this);
 		RegisterEvent(EVENT_LOAD_LEVEL_HOOK,this);
 		RegisterEvent(EVENT_OBJECT_CREATE_HOOK,this);
 	}
@@ -61,42 +80,51 @@
 	{
 		UnregisterEvent(EVENT_GAME_OVER_HOOK,this);
 		UnregisterEvent(EVENT_GLOBAL_INI,this);
+		UnregisterEvent(EVENT_MAP_INI,this);
 		UnregisterEvent(EVENT_LOAD_LEVEL_HOOK,this);
 		UnregisterEvent(EVENT_OBJECT_CREATE_HOOK,this);
 	}
+	void LoadGenericINISettings(INIClass *SSGMIni, const char* key, Configuration& configuration)
+	{
+		configuration.EnableCrates       = SSGMIni->Get_Bool(key, "EnableCrates",    configuration.EnableCrates);
+		configuration.EnableNewCrates    = SSGMIni->Get_Bool(key, "EnableNewCrates", configuration.EnableNewCrates);
+		configuration.VehCrate           = SSGMIni->Get_Bool(key, "AllowVehCrates",  configuration.VehCrate);
+		configuration.CrateWeapon        = SSGMIni->Get_Int (key, "Weapon",          configuration.CrateWeapon);
+		configuration.CrateMoney         = SSGMIni->Get_Int (key, "Money",           configuration.CrateMoney);
+		configuration.CratePoints        = SSGMIni->Get_Int (key, "Points",          configuration.CratePoints);
+		configuration.CrateVehicle       = SSGMIni->Get_Int (key, "Vehicle",         configuration.CrateVehicle);
+		configuration.CrateDeath         = SSGMIni->Get_Int (key, "Death",           configuration.CrateDeath);
+		configuration.CrateTiberium      = SSGMIni->Get_Int (key, "Tiberium",        configuration.CrateTiberium);
+		configuration.CrateAmmo          = SSGMIni->Get_Int (key, "Ammo",            configuration.CrateAmmo);
+		configuration.CrateArmor         = SSGMIni->Get_Int (key, "Armor",           configuration.CrateArmor);
+		configuration.CrateHealth        = SSGMIni->Get_Int (key, "Health",          configuration.CrateHealth);
+		configuration.CrateCharacter     = SSGMIni->Get_Int (key, "Character",       configuration.CrateCharacter);
+		configuration.CrateButterFingers = SSGMIni->Get_Int (key, "ButterFingers",   configuration.CrateButterFingers);
+		configuration.CrateRefill        = SSGMIni->Get_Int (key, "Refill",          configuration.CrateRefill);
+		configuration.CrateBeacon        = SSGMIni->Get_Int (key, "Beacon",          configuration.CrateBeacon);
+		configuration.CrateSpy           = SSGMIni->Get_Int (key, "Spy",             configuration.CrateSpy);
+		configuration.CrateStealth       = SSGMIni->Get_Int (key, "Stealth",         configuration.CrateStealth);
+		configuration.CrateThief         = SSGMIni->Get_Int (key, "Thief",           configuration.CrateThief);
+		configuration.CrateAmmoRegen     = SSGMIni->Get_Int (key, "AmmoRegen",       configuration.CrateAmmoRegen);
+		configuration.CrateHumanSilo     = SSGMIni->Get_Int (key, "HumanSilo",       configuration.CrateHumanSilo);
+		configuration.CrateUberWire      = SSGMIni->Get_Int (key, "UberWire",        configuration.CrateUberWire);
+	}
 	virtual void OnLoadGlobalINISettings(INIClass *SSGMIni)
 	{
-		EnableCrates = SSGMIni->Get_Bool("Crates","EnableCrates",true);
-		EnableNewCrates = SSGMIni->Get_Bool("Crates","EnableNewCrates",false);
-		if (EnableNewCrates)
-		{
-			VehCrate = SSGMIni->Get_Bool("Crates","AllowVehCrates",false);
-			CrateVehSpawnPos[0].X = SSGMIni->Get_Float("Crates","NodRVCx",0.0f);
-			CrateVehSpawnPos[0].Y = SSGMIni->Get_Float("Crates","NodRVCy",0.0f);
-			CrateVehSpawnPos[0].Z = SSGMIni->Get_Float("Crates","NodRVCz",0.0f);
-			CrateVehSpawnPos[1].X = SSGMIni->Get_Float("Crates","GDIRVCx",0.0f);
-			CrateVehSpawnPos[1].Y = SSGMIni->Get_Float("Crates","GDIRVCy",0.0f);
-			CrateVehSpawnPos[1].Z = SSGMIni->Get_Float("Crates","GDIRVCz",0.0f);
-			CrateWeapon = SSGMIni->Get_Int("Crates","Weapon",0);
-			CrateMoney = SSGMIni->Get_Int("Crates","Money",0);
-			CratePoints = SSGMIni->Get_Int("Crates","Points",0);
-			CrateVehicle = SSGMIni->Get_Int("Crates","Vehicle",0);
-			CrateDeath = SSGMIni->Get_Int("Crates","Death",0);
-			CrateTiberium = SSGMIni->Get_Int("Crates","Tiberium",0);
-			CrateAmmo = SSGMIni->Get_Int("Crates","Ammo",0);
-			CrateArmor = SSGMIni->Get_Int("Crates","Armor",0);
-			CrateHealth = SSGMIni->Get_Int("Crates","Health",0);
-			CrateCharacter = SSGMIni->Get_Int("Crates","Character",0);
-			CrateButterFingers = SSGMIni->Get_Int("Crates","ButterFingers",0);
-			CrateRefill = SSGMIni->Get_Int("Crates","Refill",0);
-			CrateBeacon = SSGMIni->Get_Int("Crates","Beacon",0);
-			CrateSpy = SSGMIni->Get_Int("Crates","Spy",0);
-			CrateStealth = SSGMIni->Get_Int("Crates","Stealth",0);
-			CrateThief = SSGMIni->Get_Int("Crates","Thief",0);
-			CrateAmmoRegen = SSGMIni->Get_Int("Crates","AmmoRegen",0);
-			CrateHumanSilo = SSGMIni->Get_Int("Crates","HumanSilo",0);
-			CrateUberWire = SSGMIni->Get_Int("Crates","UberWire",0);
+		globalConfiguration.setToDefaults();
+		LoadGenericINISettings(SSGMIni, "Crates", globalConfiguration);
 		}
+	virtual void OnLoadMapINISettings(INIClass *SSGMIni)
+	{
+		mapConfiguration = globalConfiguration;
+		const StringClass key = StringClass(The_Game()->Get_Map_Name()).AsLower() + "_Crates";
+		LoadGenericINISettings(SSGMIni, key, mapConfiguration);
+		mapConfiguration.CrateVehSpawnPos[0].X = SSGMIni->Get_Float(key, "NodRVCx", mapConfiguration.CrateVehSpawnPos[0].X);
+		mapConfiguration.CrateVehSpawnPos[0].Y = SSGMIni->Get_Float(key, "NodRVCy", mapConfiguration.CrateVehSpawnPos[0].Y);
+		mapConfiguration.CrateVehSpawnPos[0].Z = SSGMIni->Get_Float(key, "NodRVCz", mapConfiguration.CrateVehSpawnPos[0].Z);
+		mapConfiguration.CrateVehSpawnPos[1].X = SSGMIni->Get_Float(key, "GDIRVCx", mapConfiguration.CrateVehSpawnPos[1].X);
+		mapConfiguration.CrateVehSpawnPos[1].Y = SSGMIni->Get_Float(key, "GDIRVCy", mapConfiguration.CrateVehSpawnPos[1].Y);
+		mapConfiguration.CrateVehSpawnPos[1].Z = SSGMIni->Get_Float(key, "GDIRVCz", mapConfiguration.CrateVehSpawnPos[1].Z);
 	}
 	virtual void OnObjectCreate(void *data,GameObject *obj)
 	{
@@ -105,38 +133,34 @@
 			if (stristr(Commands->Get_Preset_Name(obj),"crate"))
 			{
 				Attach_Script_Once(obj,"SSGM_Crate","");
-				if (EnableNewCrates)
-				{
-					Remove_Script(obj,"M00_CNC_Crate");
-				}
 			}
 		}
 	}
 	virtual void OnLoadLevel()
 	{
-		if (EnableNewCrates)
+		if (mapConfiguration.EnableNewCrates)
 		{
-			int	Total = CrateUberWire + CrateHumanSilo + CrateAmmoRegen + CrateDeath + CrateVehicle + CrateWeapon + CrateCharacter + CrateMoney + CratePoints + CrateTiberium + CrateAmmo + CrateHealth + CrateArmor + CrateRefill + CrateButterFingers + CrateSpy + CrateThief + CrateBeacon + CrateStealth;
+			int	Total = mapConfiguration.CrateUberWire + mapConfiguration.CrateHumanSilo + mapConfiguration.CrateAmmoRegen + mapConfiguration.CrateDeath + mapConfiguration.CrateVehicle + mapConfiguration.CrateWeapon + mapConfiguration.CrateCharacter + mapConfiguration.CrateMoney + mapConfiguration.CratePoints + mapConfiguration.CrateTiberium + mapConfiguration.CrateAmmo + mapConfiguration.CrateHealth + mapConfiguration.CrateArmor + mapConfiguration.CrateRefill + mapConfiguration.CrateButterFingers + mapConfiguration.CrateSpy + mapConfiguration.CrateThief + mapConfiguration.CrateBeacon + mapConfiguration.CrateStealth;
 			if (Total != 100) {
-				CrateWeapon = 10;
-				CrateMoney = 10;
-				CratePoints = 10;
-				CrateVehicle = 8;
-				CrateDeath = 8;
-				CrateTiberium = 6;
-				CrateAmmo = 5;
-				CrateArmor = 5;
-				CrateHealth = 5;
-				CrateCharacter = 8;
-				CrateButterFingers = 3;
-				CrateSpy = 3;
-				CrateStealth = 3;
-				CrateRefill = 6;
-				CrateBeacon = 4;
-				CrateThief = 2;
-				CrateAmmoRegen = 2;
-				CrateHumanSilo = 1;
-				CrateUberWire = 1;
+				mapConfiguration.CrateWeapon = 10;
+				mapConfiguration.CrateMoney = 10;
+				mapConfiguration.CratePoints = 10;
+				mapConfiguration.CrateVehicle = 8;
+				mapConfiguration.CrateDeath = 8;
+				mapConfiguration.CrateTiberium = 6;
+				mapConfiguration.CrateAmmo = 5;
+				mapConfiguration.CrateArmor = 5;
+				mapConfiguration.CrateHealth = 5;
+				mapConfiguration.CrateCharacter = 8;
+				mapConfiguration.CrateButterFingers = 3;
+				mapConfiguration.CrateSpy = 3;
+				mapConfiguration.CrateStealth = 3;
+				mapConfiguration.CrateRefill = 6;
+				mapConfiguration.CrateBeacon = 4;
+				mapConfiguration.CrateThief = 2;
+				mapConfiguration.CrateAmmoRegen = 2;
+				mapConfiguration.CrateHumanSilo = 1;
+				mapConfiguration.CrateUberWire = 1;
 				StringClass msg;
 				msg.Format("Total crate percentages equal %d instead of 100. Using default percentages.",Total);
 				SSGMGameLog::Log_Message(msg,"_ERROR");
@@ -230,10 +254,10 @@
 	{
 		Vector3	pos	= Commands->Get_Position(obj);
 		SSGMGameLog::Log_Gamelog("CREATED;CRATE;%d;%s;%d;%d;%d;%d;%d;%d;%d", Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(pos.Y),int(pos.X),int(pos.Z), int(Commands->Get_Facing(obj)), int(Commands->Get_Max_Health(obj)),int(Commands->Get_Max_Shield_Strength(obj)), int(Commands->Get_Player_Type(obj)));
-		if (!crate.EnableCrates) {
+		if (!crate.mapConfiguration.EnableCrates) {
 			Commands->Destroy_Object(obj);
 		}
-		else if (crate.EnableNewCrates) {
+		else if (crate.mapConfiguration.EnableNewCrates) {
 			if (crate.CrateExists || (The_Game()->Get_Game_Duration_S() - crate.CrateLastPickup) < 180)
 			{
 				Commands->Destroy_Object(obj);
@@ -254,7 +278,7 @@
 	void Custom(GameObject *obj,int type,int param,GameObject *sender)
 	{
 		if (type == CUSTOM_EVENT_POWERUP_GRANTED && !PickedUp) {
-			if (crate.VehCrate || !Get_Vehicle(sender)) {
+			if (crate.mapConfiguration.VehCrate || !Get_Vehicle(sender)) {
 				int Team = Get_Object_Type(sender);
 				if (Team > 1 || Team < 0) {
 					return;
@@ -271,7 +295,7 @@
 				CrateStart:
 				int RandomIntCrate = Commands->Get_Random_Int(1,101);
 				int	percent	= 0;
-				if ((RandomIntCrate	<= (percent+=crate.CrateWeapon)) && (crate.CrateWeapon > 0)) {
+				if ((RandomIntCrate	<= (percent+=crate.mapConfiguration.CrateWeapon)) && (crate.mapConfiguration.CrateWeapon > 0)) {
 					Reselect:
 					int	Rnd	= Commands->Get_Random_Int(1,101);
 					int	Index = 0;
@@ -300,12 +324,12 @@
 					if (RandomWeapon[Index][2][0] != '\0') {
 						Create_2D_WAV_Sound_Player(sender,RandomWeapon[Index][2]);
 					}
-					message1.Format("ppage %d [Crate] You just got a %s from the Random Weapon Crate.",Get_Player_ID(sender),RandomWeapon[Index][0]);
-					message2.Format("%ls picked up a Random Weapon Crate.",Get_Wide_Player_Name(sender));
+					message1.Format("ppage %d [Crate] You just got a %s from the Random Weapon crate.mapConfiguration.",Get_Player_ID(sender),RandomWeapon[Index][0]);
+					message2.Format("%ls picked up a Random Weapon crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 					Vector3 pos	= Commands->Get_Position(sender);
 					message3.Format("CRATE;WEAPON;%s;%d;%s;%f;%f;%f;%f;%f;%f;%d",RandomWeapon[Index][0],Commands->Get_ID(sender),Commands->Get_Preset_Name(sender),pos.Y,pos.X,pos.Z,Commands->Get_Facing(sender),Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CrateMoney))	&& (crate.CrateMoney	> 0)) {
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateMoney))	&& (crate.mapConfiguration.CrateMoney	> 0)) {
 					int	Amount = Commands->Get_Random_Int(1,1000);
 					int	RndGood	= Commands->Get_Random_Int(1,2);
 					if (RndGood	== 1) {
@@ -318,18 +342,18 @@
 					}
 					if (RndGood == 1) {
 						message1.Format("ppage %d [Crate] You just got the Money Crate, you have gained %d credits.",Get_Player_ID(sender),(int)Amount);
-						message2.Format("%ls picked up a Money Crate.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Money crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 						Vector3 pos = Commands->Get_Position(obj);
 						message3.Format("CRATE;MONEY;%d;%d;%s;%f;%f;%f;%f;%f;%f;%d", int(Amount),	Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z,	Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 					else {
 						message1.Format("ppage %d [Crate] You just got the Demoney Crate, you have lost %d credits.",Get_Player_ID(sender),(int)Amount);
-						message2.Format("%ls picked up a Demoney Crate.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Demoney crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 						Vector3 pos = Commands->Get_Position(obj);
 						message3.Format("CRATE;MONEY;%d;%d;%s;%f;%f;%f;%f;%f;%f;%d", int(Amount) * -1, Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}			
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CratePoints)) &&	(crate.CratePoints >	0)) {
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CratePoints)) &&	(crate.mapConfiguration.CratePoints >	0)) {
 					int	Amount = Commands->Get_Random_Int(1,500);
 					int	RndGood	= Commands->Get_Random_Int(1,2);
 					if (RndGood	== 1) {
@@ -340,7 +364,7 @@
 					}
 
 					if (RndGood == 1) {
-						message2.Format("%ls picked up a Points Crate.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Points crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 						message1.Format("ppage %d [Crate] You just got the Points Crate, you have gained %d points.",Get_Player_ID(sender),(int)Amount);
 						StringClass msg;
 						const char *str = Get_Team_Name(Team);
@@ -351,7 +375,7 @@
 						message3.Format("CRATE;POINTS;%d;%d;%s;%f;%f;%f;%f;%f;%f;%d",int(Amount), Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 					else {
-						message2.Format("%ls picked up a Depoints Crate.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Depoints crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 						message1.Format("ppage %d [Crate] You just got the Depoints Crate, you lost %d points.",Get_Player_ID(sender),(int)Amount);
 						StringClass msg;
 						const char *str = Get_Team_Name(Team);
@@ -362,11 +386,11 @@
 						message3.Format("CRATE;POINTS;%d;%d;%s;%f;%f;%f;%f;%f;%f;%d",int(Amount)	* -1, Commands->Get_ID(sender),	Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender),	Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}		
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CrateVehicle)) && (crate.CrateVehicle	> 0)) {
-					if (Get_Vehicle(sender) || crate.CrateVehSpawnPos[0].X == 0.0f || crate.CrateVehSpawnPos[0].Y == 0.0f || crate.CrateVehSpawnPos[0].Z == 0.0f || crate.CrateVehSpawnPos[1].X == 0.0f || crate.CrateVehSpawnPos[1].Y == 0.0f || crate.CrateVehSpawnPos[1].Z == 0.0f) {
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateVehicle)) && (crate.mapConfiguration.CrateVehicle	> 0)) {
+					if (Get_Vehicle(sender) || crate.mapConfiguration.CrateVehSpawnPos[0].X == 0.0f || crate.mapConfiguration.CrateVehSpawnPos[0].Y == 0.0f || crate.mapConfiguration.CrateVehSpawnPos[0].Z == 0.0f || crate.mapConfiguration.CrateVehSpawnPos[1].X == 0.0f || crate.mapConfiguration.CrateVehSpawnPos[1].Y == 0.0f || crate.mapConfiguration.CrateVehSpawnPos[1].Z == 0.0f) {
 						goto CrateStart;
 					}
-					Vector3	Pos = crate.CrateVehSpawnPos[Get_Object_Type(sender)];
+					Vector3	Pos = crate.mapConfiguration.CrateVehSpawnPos[Get_Object_Type(sender)];
 					Damage_All_Vehicles_Area(999999.0f,"Laser_NoBuilding",Pos,2.0f,obj,0);
 					Commands->Set_Position(sender,Pos);
 
@@ -387,10 +411,10 @@
 					else if	(Rnd <=	190) Index = 10;
 					else Index = 11;
 					if (IsPresetDisabled(Get_Definition_ID(RandomVehicle[Index][2]))) goto Reselect2;		
-					message2.Format("%ls picked up a Random Vehicle Crate.",Get_Wide_Player_Name(sender));
-					message1.Format("ppage %d [Crate] You got a %s from the Random Vehicle Crate.",Get_Player_ID(sender), RandomVehicle[Index][0]);
+					message2.Format("%ls picked up a Random Vehicle crate.mapConfiguration.",Get_Wide_Player_Name(sender));
+					message1.Format("ppage %d [Crate] You got a %s from the Random Vehicle crate.mapConfiguration.",Get_Player_ID(sender), RandomVehicle[Index][0]);
 					StringClass cine;
-					cine.Format("CRATE%s.txt",Commands->Get_Player_Type(sender)	== 0?"Nod":"GDI");
+					cine.Format("%scrate.mapConfiguration.txt",Commands->Get_Player_Type(sender)	== 0?"Nod":"GDI");
 					Commands->Attach_Script(Temp,"Test_Cinematic",cine);
 					GameObject *veh = Commands->Create_Object(RandomVehicle[Index][3],Vector3(0,0,0));
 					Commands->Send_Custom_Event(Temp,Temp,CUSTOM_EVENT_CINEMATIC_SET_FIRST_SLOT+4,Commands->Get_Preset_ID(veh),0);
@@ -402,8 +426,8 @@
 					Vector3 pos = Commands->Get_Position(sender);
 					message3.Format("CRATE;VEHICLE;%s;%d;%s;%f;%f;%f;%f;%f;%f;%d", RandomVehicle[Index][0], Commands->Get_ID(sender),	Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender),	Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CrateDeath))	&& (crate.CrateDeath	> 0)) {
-					message2.Format("%ls picked up a Death Crate.",Get_Wide_Player_Name(sender));
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateDeath))	&& (crate.mapConfiguration.CrateDeath	> 0)) {
+					message2.Format("%ls picked up a Death crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 					Commands->Apply_Damage(Get_Vehicle(sender),99999,"Shrapnel",0);
 					Commands->Apply_Damage(sender,99999,"Shrapnel",0);
 					Commands->Create_Explosion("Explosion_Mine_Proximity_01",Commands->Get_Position(obj),0);
@@ -417,8 +441,8 @@
 					pos	= Commands->Get_Position(sender);
 					message3.Format("CRATE;DEATH;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CrateTiberium)) && (crate.CrateTiberium >	0)) {
-					message2.Format("%ls picked up a Tiberium Death Crate.",Get_Wide_Player_Name(sender));
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateTiberium)) && (crate.mapConfiguration.CrateTiberium >	0)) {
+					message2.Format("%ls picked up a Tiberium Death crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 					Commands->Apply_Damage(Get_Vehicle(sender),99999,"Shrapnel",0);
 					Commands->Apply_Damage(sender,99999,"TiberiumRaw",false);
 					Commands->Create_Object("CnC_Visceroid",Commands->Get_Position(sender));
@@ -427,55 +451,55 @@
 					Vector3	pos	= Commands->Get_Position(sender);
 					message3.Format("CRATE;TIBERIUMDEATH;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CrateAmmo)) && (crate.CrateAmmo > 0)) {
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateAmmo)) && (crate.mapConfiguration.CrateAmmo > 0)) {
 					Commands->Give_PowerUp(sender,"CnC_POW_Ammo_ClipMax",false);
 					Commands->Give_PowerUp(sender,"CnC_POW_Ammo_ClipMax",false);
 					Commands->Give_PowerUp(sender,"CnC_POW_Ammo_ClipMax",false);
 					Commands->Give_PowerUp(sender,"CnC_POW_Ammo_ClipMax",false);
-					message2.Format("%ls picked up a Full Ammo Crate.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up a Full Ammo crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 					message1.Format("ppage %d [Crate] You just got the Full Ammo Crate, your ammo has been refilled.",Get_Player_ID(sender));
 					Create_2D_WAV_Sound_Player(sender,"m00puar_aqob0002i1evag_snd.wav");
 					Vector3	pos	= Commands->Get_Position(sender);
 					message3.Format("CRATE;FULLAMMO;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z,	Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CrateArmor)) && (crate.CrateArmor > 0)) {
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateArmor)) && (crate.mapConfiguration.CrateArmor > 0)) {
 					int	RndGood	= Commands->Get_Random_Int(1,3);
 					if (Commands->Get_Shield_Strength(sender) <	2) RndGood = 1;
 					if (RndGood	== 1) {
 						Commands->Give_PowerUp(sender,"POW_Medal_Armor",true);
-						message2.Format("%ls picked up an Armor Crate.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up an Armor crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 						message1.Format("ppage %d [Crate] You just got the Armor Crate, your max armor has been increased!",Get_Player_ID(sender));
 						Vector3	pos	= Commands->Get_Position(sender);
 						message3.Format("CRATE;ARMORINCREASE;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 					else {
 						Commands->Set_Shield_Strength(sender,1);
-						message2.Format("%ls picked up a Dearmor Crate.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Dearmor crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 						message1.Format("ppage %d [Crate] You just got the Dearmor Crate, your armor has been set to 1.",Get_Player_ID(sender));
 						Vector3	pos	= Commands->Get_Position(sender);
 						message3.Format("CRATE;ARMORLOST;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CrateHealth)) &&	(crate.CrateHealth >	0)) {
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateHealth)) &&	(crate.mapConfiguration.CrateHealth >	0)) {
 					int	RndGood	= Commands->Get_Random_Int(1,3);
 					if (Commands->Get_Health(sender) ==	1) RndGood = 1;
 					if (RndGood	== 1) {
 						Commands->Give_PowerUp(sender,"POW_Medal_Health",true);
-						message2.Format("%ls picked up a Health Crate.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Health crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 						message1.Format("ppage %d [Crate] You just got the Health Crate, your max health has been increased!",Get_Player_ID(sender));
 						Vector3	pos	= Commands->Get_Position(sender);
 						message3.Format("CRATE;HEALTHUPGRADE;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 					else {
 						Commands->Set_Health(sender,1);
-						message2.Format("%ls picked up a Dehealth Crate.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Dehealth crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 						message1.Format("ppage %d [Crate] You just got the Dehealth Crate, your health has been set to 1.",Get_Player_ID(sender));
 						Create_2D_WAV_Sound_Player(sender,"m00evag_dsgn0026i1evag_snd.wav");
 						Vector3 pos = Commands->Get_Position(sender);
 						message3.Format("CRATE;HEALTHREDUCE;;%d;%s;%f;%f;%f;%f;%f;%f;%d",	Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z,	Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CrateCharacter))	&& (crate.CrateCharacter	> 0)) {
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateCharacter))	&& (crate.mapConfiguration.CrateCharacter	> 0)) {
 					if (Get_Vehicle(sender)) {
 						goto CrateStart;
 					}
@@ -498,21 +522,21 @@
 					else if (Team == 0 && IsPresetDisabled(Get_Definition_ID(RandomNodChar[Index][1]))) {
 						goto Reselect3;
 					}
-					message2.Format("%ls picked up a Random Character Crate.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up a Random Character crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 					if (Commands->Get_Player_Type(sender) == 1) {
 						Change_Character(sender,RandomGDIChar[Index][1]);
-						message1.Format("ppage %d [Crate] You have been transformed into a %s by the Random Character Crate.",Get_Player_ID(sender),RandomGDIChar[Index][0]);
+						message1.Format("ppage %d [Crate] You have been transformed into a %s by the Random Character crate.mapConfiguration.",Get_Player_ID(sender),RandomGDIChar[Index][0]);
 						Vector3	pos	= Commands->Get_Position(sender);
 						message3.Format("CRATE;CHARACTER;%s;%d;%s;%f;%f;%f;%f;%f;%f;%d", RandomGDIChar[Index][0],	Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z,	Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 					else {
 						Change_Character(sender,RandomNodChar[Index][1]);
-						message1.Format("ppage %d [Crate] You have been transformed into a %s by the Random Character Crate.",Get_Player_ID(sender),RandomNodChar[Index][0]);
+						message1.Format("ppage %d [Crate] You have been transformed into a %s by the Random Character crate.mapConfiguration.",Get_Player_ID(sender),RandomNodChar[Index][0]);
 						Vector3	pos	= Commands->Get_Position(sender);
 						message3.Format("CRATE;CHARACTER;%s;%d;%s;%f;%f;%f;%f;%f;%f;%d", RandomNodChar[Index][0],	Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z,	Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 					}
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CrateButterFingers))	&& (crate.CrateButterFingers	> 0)) {
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateButterFingers))	&& (crate.mapConfiguration.CrateButterFingers	> 0)) {
 					Commands->Clear_Weapons(sender);
 					int	Rnd	= Commands->Get_Random_Int(1,3);
 					if (Rnd	== 1) {
@@ -523,26 +547,26 @@
 						Commands->Give_PowerUp(sender,"CnC_POW_MineTimed_Player_01",false);
 						Commands->Select_Weapon(sender,"CnC_Weapon_MineTimed_Player");
 					}
-					message2.Format("%ls picked up the Butter Fingers Crate.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up the Butter Fingers crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 					message1.Format("ppage %d [Crate] You picked up the Butter Fingers Crate, you have dropped most of your weapons.",Get_Player_ID(sender));
 					Vector3	pos	= Commands->Get_Position(sender);
 					message3.Format("CRATE;BUTTERFINGER;;%d;%s;%f;%f;%f;%f;%f;%f;%d",Commands->Get_ID(sender), Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z,	Commands->Get_Facing(sender), Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CrateRefill)) &&	(crate.CrateRefill >	0)) {
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateRefill)) &&	(crate.mapConfiguration.CrateRefill >	0)) {
 					Grant_Refill(sender);
-					message2.Format("%ls picked up the Refill Crate.",Get_Wide_Player_Name(sender));
+					message2.Format("%ls picked up the Refill crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 					message1.Format("ppage %d [Crate] You just got the Refill Crate, your health, armor, and ammo have all been refilled.",Get_Player_ID(sender));
 					Create_2D_WAV_Sound_Player(sender,"m00puar_aqob0002i1evag_snd.wav");
 					Vector3	pos	= Commands->Get_Position(sender);
 					message3.Format("CRATE;REFILL;;%d;%s;%f;%f;%f;%f;%f;%f;%d", Commands->Get_ID(sender),	Commands->Get_Preset_Name(sender), pos.Y,pos.X,pos.Z, Commands->Get_Facing(sender),	Commands->Get_Max_Health(sender),Commands->Get_Max_Shield_Strength(sender),Get_Object_Type(sender));
 				}
-				else if	((RandomIntCrate <=	(percent+=crate.CrateBeacon)) &&	(crate.CrateBeacon >	0)) {
+				else if	((RandomIntCrate <=	(percent+=crate.mapConfiguration.CrateBeacon)) &&	(crate.mapConfiguration.CrateBeacon >	0)) {
 					if (DisableBeacons) {
 						goto CrateStart;
 					}
 					int	RndGood	= Commands->Get_Random_Int(1,3);
 					if (RndGood	== 1) {
-						message2.Format("%ls picked up a Beacon Crate.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Beacon crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 						if (Commands->Get_Player_Type(sender) == 1) {
 							TeamPurchaseSettingsDefClass *PT = TeamPurchaseSettingsDefClass::Get_Definition(TeamPurchaseSettingsDefClass::TEAM_GDI);
 							Commands->Give_PowerUp(sender,Get_Definition_Name(PT->Get_Beacon_Definition()),true);
@@ -562,7 +586,7 @@
 						Commands->Create_Object("Beacon_Nuke_Strike_Anim_Post",Commands->Get_Position(obj));
 						Commands->Create_Explosion("Explosion_NukeBeacon",Commands->Get_Position(obj),0);
 						Damage_All_Objects_Area(2500.0f,"None",Commands->Get_Position(obj),15.0f,obj,0);
-						message2.Format("%ls picked up a Nuclear Bomb Crate.",Get_Wide_Player_Name(sender));
+						message2.Format("%ls picked up a Nuclear Bomb crate.mapConfiguration.",Get_Wide_Player_Name(sender));
 						message1.Format("ppage %d [Crate] You just got a Nuclear Bomb Crate, you have been killed. Sorry :(",Get_Player_ID(sender));
 						StringClass msg;
 						const char *str = Get_Team_Name(Team);
